/*
 * Created on 7.2.2006
 *
 */
package cz.muni.fi.pb138.demo.sax;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLFilterImpl;

public class CounterFilter extends XMLFilterImpl {

    private int elementCount;

    private int attributeCount;

    /**
     * Resets the total number of elements and attributes
     * @see org.xml.sax.helpers.DefaultHandler#startDocument()
     */
    @Override
    public void startDocument() throws SAXException {
        elementCount = 0;
        attributeCount = 0;
        super.startDocument();
    }

    /**
     * Prints the total number of elements and attributes
     * @see org.xml.sax.helpers.DefaultHandler#endDocument()
     */
    @Override
    public void endDocument() throws SAXException {
        echo("Total element count=" + elementCount);
        echo("Total attribute count=" + attributeCount);
        super.endDocument();
    }

    /**
     * @see org.xml.sax.helpers.DefaultHandler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
     */
    @Override
    public void startElement(String uri, String localName, String qName,
            Attributes attributes) throws SAXException {
        elementCount++;
        attributeCount += attributes.getLength();
        super.startElement(uri, localName, qName, attributes);
    }

    protected void echo(String s) {
        System.out.println(s);
    }
}
