/*
 * Created on 7.2.2006
 *
  */
package cz.muni.fi.pb138.demo.sax;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class EchoContentHandler extends DefaultHandler {

    /**
     * 
     * @see org.xml.sax.helpers.DefaultHandler#endDocument()
     */
    @Override
    public void endDocument() throws SAXException {
        echo("END Document");
        super.endDocument();
    }

    /**
     * @see org.xml.sax.helpers.DefaultHandler#endElement(java.lang.String, java.lang.String, java.lang.String)
     */
    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException {
        echo("END Element");
        super.endElement(uri, localName, qName);
    }

    /**
     * @see org.xml.sax.helpers.DefaultHandler#startDocument()
     */
    @Override
    public void startDocument() throws SAXException {
        super.startDocument();
        echo("START Document");
    }

    /**
     * @see org.xml.sax.helpers.DefaultHandler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
     */
    @Override
    public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
        echo("START Element local name="+localName+", namespace URI="+uri+", qualified name="+qName);
        super.startElement(uri, localName, qName, attributes);
    }
    
    protected void echo(String s) {
        System.out.println(s);
    }

}
