/*
 * Created on 7.2.2006
 *
 */
package cz.muni.fi.pb138.demo.sax;

import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLFilterImpl;

public class TextExtractionFilter extends XMLFilterImpl {
    
    private StringBuffer buffer;

    /**
     * Resets the total number of elements and attributes
     * @see org.xml.sax.helpers.DefaultHandler#startDocument()
     */
    @Override
    public void startDocument() throws SAXException {
        buffer = new StringBuffer();
        super.startDocument();
    }

    /**
     * Prints the total number of elements and attributes
     * @see org.xml.sax.helpers.DefaultHandler#endDocument()
     */
    @Override
    public void endDocument() throws SAXException {
        echo("Text nodes content extracted:");
        echo(buffer.toString());
        super.endDocument();
    }

    /**
     * Accumulates all the non-whitespace text nodes into the buffer.
     * Note, however, that without a DTD, all text nodes are accumulated.
     * 
     * @see org.xml.sax.helpers.XMLFilterImpl#characters(char[], int, int)
     */
    @Override
    public void characters(char[] ch, int start, int length) throws SAXException {
        buffer.append(ch, start, length);
        super.characters(ch, start, length);
    }

    protected void echo(String s) {
        System.out.println(s);
    }
}
